package com.nudt.drawrss;

import java.util.ArrayList;
import java.util.List;
 
 import org.achartengine.ChartFactory;
 import org.achartengine.GraphicalView;
 import org.achartengine.chart.PointStyle;
 import org.achartengine.model.XYMultipleSeriesDataset;
 import org.achartengine.model.XYSeries;
 import org.achartengine.renderer.XYMultipleSeriesRenderer;
 import org.achartengine.renderer.XYSeriesRenderer;
 import android.content.Context;
 import android.graphics.Color;
import android.graphics.Paint.Align;
 
 public class ChartService {
 
     private GraphicalView mGraphicalView;
     private XYMultipleSeriesDataset multipleSeriesDataset;// ݼ
     private XYMultipleSeriesRenderer multipleSeriesRenderer;// Ⱦ
     private XYSeries mSeries1;// ݼ
     private XYSeriesRenderer mRenderer1;// Ⱦ
     private XYSeries[] mSeries;// ݼ
     private XYSeriesRenderer[] mRenderer;// Ⱦ
     private int LineNo;

     private Context context;
     private double maxX;
 
     public ChartService(Context context) {
         this.context = context;
     }
     
     public ChartService(Context context, int No) {
         this.context = context;
         LineNo = No;
     }
 
     /**
      * ȡͼ
      * 
      * @return
      */
     public GraphicalView getGraphicalView() {
         mGraphicalView = ChartFactory.getCubeLineChartView(context,
                 multipleSeriesDataset, multipleSeriesRenderer, 0.5f);
         return mGraphicalView;
     }
 
     /**
      * ȡݼxyļ
      * 
      * @param curveTitle
      */
     public void setXYMultipleSeriesDataset(String curveTitle) {
         multipleSeriesDataset = new XYMultipleSeriesDataset();
         mSeries1 = new XYSeries(curveTitle);
         multipleSeriesDataset.addSeries(mSeries1);
     }
     
     public void setXYMultipleSeriesDataset(String[] curveTitle) 
     {    	 
         multipleSeriesDataset = new XYMultipleSeriesDataset();
         for(int i = 0;i < LineNo;i++)
         {
        	 mSeries[i] = new XYSeries(curveTitle[i]); 
        	 multipleSeriesDataset.addSeries(mSeries[i]);
         }       
     }
 
     /**
      * ȡȾ
      * 
      * @param maxX
      *            xֵ
      * @param maxY
      *            yֵ
      * @param chartTitle
      *            ߵı
      * @param xTitle
      *            x
      * @param yTitle
      *            y
      * @param axeColor
      *            ɫ
      * @param labelColor
      *            ɫ
      * @param curveColor
      *            ɫ
      * @param gridColor
      *            ɫ
      */
     public void setXYMultipleSeriesRenderer(double minX, double maxX, double minY, double maxY,
             String chartTitle, String xTitle, String yTitle, int axeColor,
             int labelColor, int curveColor, int gridColor) {
         multipleSeriesRenderer = new XYMultipleSeriesRenderer();
         if (chartTitle != null) {
             multipleSeriesRenderer.setChartTitle(chartTitle);
         }
         this.maxX = maxX;
         
         multipleSeriesRenderer.setXTitle(xTitle);
         multipleSeriesRenderer.setYTitle(yTitle);
         multipleSeriesRenderer.setRange(new double[] { minX, maxX, minY, maxY });//xyķΧ
         multipleSeriesRenderer.setLabelsColor(labelColor);
         multipleSeriesRenderer.setXLabels(10);
         multipleSeriesRenderer.setYLabels(10);
         multipleSeriesRenderer.setXLabelsAlign(Align.RIGHT);
         multipleSeriesRenderer.setYLabelsAlign(Align.RIGHT);
         multipleSeriesRenderer.setAxisTitleTextSize(20);
         multipleSeriesRenderer.setChartTitleTextSize(20);
         multipleSeriesRenderer.setLabelsTextSize(20);
         multipleSeriesRenderer.setLegendTextSize(20);
         multipleSeriesRenderer.setPointSize(8f);//ߴ
         multipleSeriesRenderer.setFitLegend(true);
         multipleSeriesRenderer.setMargins(new int[] { 20, 30, 15, 20 });
         multipleSeriesRenderer.setShowGrid(true);
         multipleSeriesRenderer.setZoomEnabled(true, false);
         multipleSeriesRenderer.setAxesColor(axeColor);
         multipleSeriesRenderer.setGridColor(gridColor);
         multipleSeriesRenderer.setBackgroundColor(Color.WHITE);//ɫ
         multipleSeriesRenderer.setMarginsColor(Color.WHITE);//߾౳ɫĬϱɫΪɫ޸Ϊɫ
         mRenderer1 = new XYSeriesRenderer();
         mRenderer1.setColor(curveColor);
         mRenderer1.setPointStyle(PointStyle.POINT);//񣬿ΪԲ㣬εȵ
         mRenderer1.setLineWidth(8);
         multipleSeriesRenderer.addSeriesRenderer(mRenderer1);
     }
     
     public void setXYMultipleSeriesRenderer(double minX, double maxX, double minY, double maxY,
             String chartTitle, String xTitle, String yTitle, int axeColor,
             int labelColor, int gridColor) {
         multipleSeriesRenderer = new XYMultipleSeriesRenderer();
         if (chartTitle != null) {
             multipleSeriesRenderer.setChartTitle(chartTitle);
         }
         this.maxX = maxX;
         
         multipleSeriesRenderer.setXTitle(xTitle);
         multipleSeriesRenderer.setYTitle(yTitle);
         multipleSeriesRenderer.setRange(new double[] { minX, maxX, minY, maxY });//xyķΧ
         multipleSeriesRenderer.setLabelsColor(labelColor);
         multipleSeriesRenderer.setXLabels(10);
         multipleSeriesRenderer.setYLabels(10);
         multipleSeriesRenderer.setXLabelsAlign(Align.RIGHT);
         multipleSeriesRenderer.setYLabelsAlign(Align.RIGHT);
         multipleSeriesRenderer.setAxisTitleTextSize(20);
         multipleSeriesRenderer.setChartTitleTextSize(20);
         multipleSeriesRenderer.setLabelsTextSize(20);
         multipleSeriesRenderer.setLegendTextSize(20);
         multipleSeriesRenderer.setPointSize(8f);//ߴ
         multipleSeriesRenderer.setFitLegend(true);
         multipleSeriesRenderer.setMargins(new int[] { 20, 30, 15, 20 });
         multipleSeriesRenderer.setShowGrid(true);
         multipleSeriesRenderer.setZoomEnabled(true, false);
         multipleSeriesRenderer.setAxesColor(axeColor);
         multipleSeriesRenderer.setGridColor(gridColor);
         multipleSeriesRenderer.setBackgroundColor(Color.WHITE);//ɫ
         multipleSeriesRenderer.setMarginsColor(Color.WHITE);//߾౳ɫĬϱɫΪɫ޸Ϊɫ
         for(int i = 0;i< LineNo;i++)
         {
        	 mRenderer[i] = new XYSeriesRenderer();
        	 if(i == 0)
        	 {
        		  mRenderer[i].setColor(Color.DKGRAY);
        		  mRenderer[i].setPointStyle(PointStyle.POINT);
        		  mRenderer[i].setLineWidth(10);
        	 }
        	 else if(i == 1)
        	 {
       		  	mRenderer[i].setColor(Color.RED);
       		  	mRenderer[i].setPointStyle(PointStyle.CIRCLE);
       		  	mRenderer[i].setLineWidth(5);
        	 }
        	 else if(i == 2)
        	 {
       		  	mRenderer[i].setColor(Color.GREEN);
       		  	mRenderer[i].setPointStyle(PointStyle.DIAMOND);
       		  	mRenderer[i].setLineWidth(5);
        	 }
        	 else if(i == 3)
        	 {
       		  	mRenderer[i].setColor(Color.BLUE);
       		  	mRenderer[i].setPointStyle(PointStyle.SQUARE);
       		  	mRenderer[i].setLineWidth(5);
        	 }    
        	 else
        	 {
        		mRenderer[i].setColor(Color.rgb((int)(Math.random()*1000%255), (int)(Math.random()*1000%255), (int)(Math.random()*1000%255)));
           		mRenderer[i].setPointStyle(PointStyle.TRIANGLE);
           		mRenderer[i].setLineWidth(5);
        	 }
        	 
        	 
        	 
             multipleSeriesRenderer.addSeriesRenderer(mRenderer[i]);
         }
         
     }
 
     /**
      * ¼ӵݣߣֻ߳
      * 
      * @param x
      *            ¼ӵx
      * @param y
      *            ¼ӵy
      */
     public void updateChart(double x, double y) {
         mSeries1.add(x, y);
         if(x > maxX)
         {
        	 multipleSeriesRenderer.setXAxisMax(x+maxX/10);
        	 multipleSeriesRenderer.setXAxisMin(x-maxX*9/10);
         }
         mGraphicalView.repaint();//˴ҲԵinvalidate()         
     }
     
     public void updateChart(double x, double[] y) 
     {
    	 for(int i = 0;i< LineNo;i++)
    	 {
    		 mSeries[i].add(x, y[i]);
    	 }
         
         if(x > maxX)
         {
        	 multipleSeriesRenderer.setXAxisMax(x+maxX/10);
        	 multipleSeriesRenderer.setXAxisMin(x-maxX*9/10);
         }
         mGraphicalView.repaint();//˴ҲԵinvalidate()         
     }
     
     public void updateChart(double[] Dis) {
         mSeries1.clear();
         for(int i = 0;i<  Dis.length;i++)
         {
        	 mSeries1.add(i*-1, Dis[i]);
         }
        
         mGraphicalView.repaint();//˴ҲԵinvalidate()
     }
 
     /**
      * µݣ飬ߣֻ߳
      * @param xList
      * @param yList
      */
     public void updateChart(List<Double> xList, List<Double> yList) {
         for (int i = 0; i < xList.size(); i++) {
             mSeries1.add(xList.get(i), yList.get(i));
         }
         mGraphicalView.repaint();//˴ҲԵinvalidate()
     }
 }
