package com.nudt.drawrss;

import java.util.List;

import org.achartengine.GraphicalView;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.telephony.NeighboringCellInfo;
import android.telephony.PhoneStateListener;
import android.telephony.SignalStrength;
import android.telephony.TelephonyManager;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.LinearLayout;

public class MainActivity extends Activity
{	
	private LinearLayout mGSMCurveLayout;// GSM
	private GraphicalView mGSMView;
	private ChartService mGSMService;
	
	private LinearLayout mGSM1CurveLayout;// GSM1
	private GraphicalView mGSM1View;
	private ChartService mGSM1Service;
	
	private LinearLayout mGSM2CurveLayout;// GSM2
	private GraphicalView mGSM2View;
	private ChartService mGSM2Service;
	
	private LinearLayout mGSM3CurveLayout;// GSM3
	private GraphicalView mGSM3View;
	private ChartService mGSM3Service;
	
	private LinearLayout mGSM4CurveLayout;// GSM4
	private GraphicalView mGSM4View;
	private ChartService mGSM4Service;
	
	private LinearLayout mGSM5CurveLayout;// GSM5
	private GraphicalView mGSM53View;
	private ChartService mGSM5Service;
	
	private LinearLayout mGSM6CurveLayout;// GSM6
	private GraphicalView mGSM6View;
	private ChartService mGSM6Service;
	
	private TelephonyManager      Tel;
	private MyPhoneStateListener  MyListener;	
	
	private Button bt,btexit,btpause;

	private int delay;
	private FileHelper helper; 

	private String GSMSignal;
	
	private int gsm1;
	private int gsm2;
	private int gsm3;
	private int gsm4;
	private int gsm5;
	private int gsm6;
	
	private ScanThread thread;

	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		helper = new FileHelper(getApplicationContext()); 

		mGSMCurveLayout  = (LinearLayout) findViewById(R.id.GSM);		
		mGSM1CurveLayout = (LinearLayout) findViewById(R.id.GSM1);
		mGSM2CurveLayout = (LinearLayout) findViewById(R.id.GSM2);
		mGSM3CurveLayout = (LinearLayout) findViewById(R.id.GSM3);
		mGSM4CurveLayout = (LinearLayout) findViewById(R.id.GSM4);
		mGSM5CurveLayout = (LinearLayout) findViewById(R.id.GSM5);
		mGSM6CurveLayout = (LinearLayout) findViewById(R.id.GSM6);
		
		bt = (Button) findViewById(R.id.button);
		btexit = (Button) findViewById(R.id.exit);
		btpause = (Button) findViewById(R.id.pause);
		
		mGSMService = new ChartService(this);
		mGSMService.setXYMultipleSeriesDataset("GSM");
		mGSMService.setXYMultipleSeriesRenderer(0, 90, 0, 10, "No.", "Time", "No.",
				Color.RED, Color.RED, Color.BLUE, Color.BLACK);
		mGSMView = mGSMService.getGraphicalView();
		
		mGSM1Service = new ChartService(this);
		mGSM1Service.setXYMultipleSeriesDataset("Cell1(dBm)");
		mGSM1Service.setXYMultipleSeriesRenderer(0, 20, -100, 0, "Cell1(dBm)", "Time", "dBm.",
				Color.RED, Color.RED, Color.BLUE, Color.BLACK);
		mGSM1View = mGSM1Service.getGraphicalView();
		
		mGSM2Service = new ChartService(this);
		mGSM2Service.setXYMultipleSeriesDataset("Cell2(dBm)");
		mGSM2Service.setXYMultipleSeriesRenderer(0, 20, -100, 0, "Cell2(dBm)", "Time", "dBm.",
				Color.RED, Color.RED, Color.BLUE, Color.BLACK);
		mGSM2View = mGSM2Service.getGraphicalView();
		
		mGSM3Service = new ChartService(this);
		mGSM3Service.setXYMultipleSeriesDataset("Cell3(dBm)");
		mGSM3Service.setXYMultipleSeriesRenderer(0, 20, -100, 0, "Cell3(dBm)", "Time", "dBm.",
				Color.RED, Color.RED, Color.BLUE, Color.BLACK);
		mGSM3View = mGSM3Service.getGraphicalView();
		
		mGSM4Service = new ChartService(this);
		mGSM4Service.setXYMultipleSeriesDataset("Cell4(dBm)");
		mGSM4Service.setXYMultipleSeriesRenderer(0, 20, -100, 0, "Cell2(dBm)", "Time", "dBm.",
				Color.RED, Color.RED, Color.BLUE, Color.BLACK);
		mGSM4View = mGSM4Service.getGraphicalView();
		
		mGSM5Service = new ChartService(this);
		mGSM5Service.setXYMultipleSeriesDataset("Cell5(dBm)");
		mGSM5Service.setXYMultipleSeriesRenderer(0, 20, -100, 0, "Cell5(dBm)", "Time", "dBm.",
				Color.RED, Color.RED, Color.BLUE, Color.BLACK);
		mGSM53View = mGSM5Service.getGraphicalView();		
		
		mGSM6Service = new ChartService(this);
		mGSM6Service.setXYMultipleSeriesDataset("Cell6(dBm)");
		mGSM6Service.setXYMultipleSeriesRenderer(0, 20, -100, 0, "Cell1(dBm)", "Time", "dBm.",
				Color.RED, Color.RED, Color.BLUE, Color.BLACK);
		mGSM6View = mGSM6Service.getGraphicalView();		
		
		mGSMCurveLayout.addView(mGSMView, new LayoutParams(
				LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));	
		
		mGSM1CurveLayout.addView(mGSM1View, new LayoutParams(
				LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));
		
		mGSM2CurveLayout.addView(mGSM2View, new LayoutParams(
				LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));
		
		mGSM3CurveLayout.addView(mGSM3View, new LayoutParams(
				LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));
		
		mGSM4CurveLayout.addView(mGSM4View, new LayoutParams(
				LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));
		
		mGSM5CurveLayout.addView(mGSM53View, new LayoutParams(
				LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));		
		
		mGSM6CurveLayout.addView(mGSM6View, new LayoutParams(
				LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));	
		
		bt.setOnClickListener(listener);
		btexit.setOnClickListener(listener);
		btpause.setOnClickListener(listener);
		
		delay = 500;
		thread = new ScanThread();
		
		MyListener = new MyPhoneStateListener();		 
	    Tel = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
	    Tel.listen(MyListener ,PhoneStateListener.LISTEN_SIGNAL_STRENGTHS);
	}
	
	private class MyPhoneStateListener extends PhoneStateListener	 
    { 
		@Override
		public void onSignalStrengthsChanged(SignalStrength signalStrength)
		{ 
			super.onSignalStrengthsChanged(signalStrength);	
 		} 
    };
	
	@Override
	protected void onResume()
	{
		Tel.listen(MyListener,PhoneStateListener.LISTEN_SIGNAL_STRENGTHS);
		super.onResume();
	}
	
	@Override
	protected void onPause()
	{
		super.onPause();
	}

	private OnClickListener listener = new OnClickListener()
	{
		@Override
		public void onClick(View btn)
		{
			if (btn.getId() == R.id.button)
			{								
				thread.start();
			}
			else if (btn.getId() == R.id.exit)
			{
				thread.stop();		
			}
			else if (btn.getId() == R.id.pause)
			{
				thread.suspend();
			}			
		}		
	}; 
		
	class ScanThread extends Thread
	{
		@Override
		public void run()
		{
			do
			{
				try
				{
					Thread.sleep(delay);
					
					Message msg = new Message();
					msg.what = 1;
					mHandler.sendMessage(msg);
				} catch (InterruptedException e)
				{
					e.printStackTrace();
				}
			} while (true);
		}
	}
	private int t = 0;
	
	private Handler mHandler = new Handler()
	{
		public void handleMessage(Message msg)
		{
			super.handleMessage(msg);
			switch (msg.what)
			{
				case 1:
				{	          
					List<NeighboringCellInfo> infos = Tel.getNeighboringCellInfo();
					GSMSignal = "\t" + infos.size();
					for(int i = 0;i < infos.size();i++)
					{
						GSMSignal += "\t"+(-113+2*infos.get(i).getRssi());
						if(i == 0)
						{
							gsm1 = (-113+2*infos.get(i).getRssi());
							mGSM1Service.updateChart(t,gsm1);
						}
						else if(i == 1)
						{
							gsm2 = (-113+2*infos.get(i).getRssi());
							mGSM2Service.updateChart(t,gsm2);
						}
						else if(i == 2)
						{
							gsm3 = (-113+2*infos.get(i).getRssi());
							mGSM3Service.updateChart(t,gsm3);
						}
						else if(i == 3)
						{
							gsm4 = (-113+2*infos.get(i).getRssi());
							mGSM4Service.updateChart(t,gsm4);
						}
						else if(i == 4)
						{
							gsm5 = (-113+2*infos.get(i).getRssi());
							mGSM5Service.updateChart(t,gsm5);
						}
						else if(i == 5)
						{
							gsm6 = (-113+2*infos.get(i).getRssi());
							mGSM6Service.updateChart(t,gsm6);
						}
					}
					mGSMService.updateChart(t,infos.size());
					helper.writeSDFile(GSMSignal, "gsm.txt");
					t++;
					break;
				}
				default:
					break;
			}
		}
	};

	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
}